Attribute VB_Name = "modListView"
' Modulname : vbzListView.bas
' Version   : Auszug fr ColumnOrder Demo
' Stand     : 27.02.2011
' Quelle    : http://www.vb-zentrum.de

Option Explicit

' Konstanten:
Private Const LVM_FIRST As Long = &H1000&
Private Const LVM_SETCOLUMNORDERARRAY As Long = (LVM_FIRST + 58)
Private Const LVM_GETCOLUMNORDERARRAY As Long = (LVM_FIRST + 59)

' Extended ListView Styles, nur Common Controls 5.0
Private Const LVM_SETEXTENDEDLISTVIEWSTYLE As Long = (LVM_FIRST + 54)
Public Enum LVW_EX_STYLES
  LVS_EX_SUBITEMIMAGES = &H2&
  LVS_EX_CHECKBOXES = &H4&
  LVS_EX_TRACKSELECT = &H8&
  LVS_EX_HEADERDRAGDROP = &H10&
  LVS_EX_FULLROWSELECT = &H20&
  LVS_EX_ONECLICKACTIVATE = &H40&
  LVS_EX_TWOCLICKACTIVATE = &H80&
  LVS_EX_FLATSB = &H100&
  LVS_EX_REGIONAL = &H200&
  LVS_EX_INFOTIP = &H400&
  LVS_EX_UNDERLINEHOT = &H800&
  LVS_EX_UNDERLINECOLD = &H1000&
  LVS_EX_MULTIWORKAREAS = &H2000&
  LVS_EX_LABELTIP = &H4000&
  LVS_EX_BORDERSELECT = &H8000&
  LVS_EX_DOUBLEBUFFER = &H10000        ' ab Windows XP!
  LVS_EX_HIDELABELS = &H20000
  LVS_EX_SINGLEROW = &H40000
  LVS_EX_SNAPTOGRID = &H80000
  LVS_EX_SIMPLESELECT = &H100000
  LVS_EX_HEADERINALLVIEWS = &H2000000  ' ab Vista (Header in allen Ansichten)!
End Enum

' Declaration Systemfunktionen:
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
        ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
        ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

' ListView Syle-Erweiterungen, nur Common Controls 5.0
Public Sub lvwSetExtendedStyle(ByVal hwnd As Long, ByVal lStyle As LVW_EX_STYLES, ByVal value As Boolean)
  Dim mask As Long
  
  If value Then mask = lStyle
  SendMessageLong hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, ByVal lStyle, ByVal mask
End Sub

Public Sub lvwLoadColumnOrder(ByVal lstView As Object)
  Dim nr As Long, cols() As Long
  Dim regString As String
  
  With lstView
    nr = .ColumnHeaders.Count
    If nr = 0 Then Exit Sub
    regString = GetSetting(App.Title, "Settings", .Parent.Name & "." & .Name & "_Columns", "0;")
    cols = pStringToLongArray(regString)
    If UBound(cols) > nr Then ReDim Preserve cols(nr)
    pSetColumnOrderArray .hwnd, UBound(cols), cols(0)
  End With
End Sub

Public Sub lvwSaveColumnOrder(ByVal lstView As Object)
  Dim nr As Long, cols() As Long
  Dim regString As String
  
  With lstView
    nr = .ColumnHeaders.Count
    If nr = 0 Then Exit Sub
    pGetColumnOrderArray .hwnd, nr, cols
    regString = pLongArrayToString(cols)
    SaveSetting App.Title, "Settings", .Parent.Name & "." & .Name & "_Columns", regString
  End With
End Sub


' ######################################################################################################## '
' # PRIVATE (p) HELPER FUNCTIONS                                                                         # '
' ######################################################################################################## '

Private Function pSetColumnOrderArray(ByVal hwnd As Long, ByVal iCount As Long, _
                                        ByRef lpiArray As Long) As Boolean
  pSetColumnOrderArray = SendMessage(hwnd, LVM_SETCOLUMNORDERARRAY, ByVal iCount, lpiArray)
End Function

Private Function pGetColumnOrderArray(ByVal hwnd As Long, ByVal iCount As Long, _
                                        ByRef lpiArray() As Long) As Boolean
  ReDim lpiArray(iCount - 1)
  pGetColumnOrderArray = SendMessage(hwnd, LVM_GETCOLUMNORDERARRAY, ByVal iCount, lpiArray(0))
End Function

' Wandelt ein LongArray in einen String,
' wobei das Trennzeichen optional gewhlt werden kann:
Private Function pLongArrayToString(ByRef lArray() As Long, _
                                    Optional delimiter As String = ";") As String
  Dim i As Long
  
  If IsArray(lArray) Then
    For i = LBound(lArray) To UBound(lArray)
      pLongArrayToString = pLongArrayToString & CStr(lArray(i)) & delimiter
    Next
  End If
End Function

' Zerlegt den bergebenen String gem Trennzeichen und
' gibt die Werte as LongArray zurck
Private Function pStringToLongArray(ByVal s As String, _
                                    Optional delimiter As String = ";") As Long()
  Dim i As Long
  Dim fld() As Long
  Dim fields() As String
  
  fields = Split(s, delimiter)
  ReDim fld(UBound(fields))
  For i = 0 To UBound(fields)
    fld(i) = Val(fields(i))
  Next i
  Erase fields
  pStringToLongArray = fld
End Function

